/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the GroupRolesResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GroupRolesResponse{}

// GroupRolesResponse struct for GroupRolesResponse
type GroupRolesResponse struct {
	ApplicationId         NullableString `json:"applicationId,omitempty"`
	ApplicationIdentifier NullableString `json:"applicationIdentifier,omitempty"`
	Roles                 []Role         `json:"roles,omitempty"`
}

// NewGroupRolesResponse instantiates a new GroupRolesResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGroupRolesResponse() *GroupRolesResponse {
	this := GroupRolesResponse{}
	return &this
}

// NewGroupRolesResponseWithDefaults instantiates a new GroupRolesResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGroupRolesResponseWithDefaults() *GroupRolesResponse {
	this := GroupRolesResponse{}
	return &this
}

// GetApplicationId returns the ApplicationId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupRolesResponse) GetApplicationId() string {
	if o == nil || IsNil(o.ApplicationId.Get()) {
		var ret string
		return ret
	}
	return *o.ApplicationId.Get()
}

// GetApplicationIdOk returns a tuple with the ApplicationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupRolesResponse) GetApplicationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ApplicationId.Get(), o.ApplicationId.IsSet()
}

// HasApplicationId returns a boolean if a field has been set.
func (o *GroupRolesResponse) HasApplicationId() bool {
	if o != nil && o.ApplicationId.IsSet() {
		return true
	}

	return false
}

// SetApplicationId gets a reference to the given NullableString and assigns it to the ApplicationId field.
func (o *GroupRolesResponse) SetApplicationId(v string) {
	o.ApplicationId.Set(&v)
}

// SetApplicationIdNil sets the value for ApplicationId to be an explicit nil
func (o *GroupRolesResponse) SetApplicationIdNil() {
	o.ApplicationId.Set(nil)
}

// UnsetApplicationId ensures that no value is present for ApplicationId, not even an explicit nil
func (o *GroupRolesResponse) UnsetApplicationId() {
	o.ApplicationId.Unset()
}

// GetApplicationIdentifier returns the ApplicationIdentifier field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupRolesResponse) GetApplicationIdentifier() string {
	if o == nil || IsNil(o.ApplicationIdentifier.Get()) {
		var ret string
		return ret
	}
	return *o.ApplicationIdentifier.Get()
}

// GetApplicationIdentifierOk returns a tuple with the ApplicationIdentifier field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupRolesResponse) GetApplicationIdentifierOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ApplicationIdentifier.Get(), o.ApplicationIdentifier.IsSet()
}

// HasApplicationIdentifier returns a boolean if a field has been set.
func (o *GroupRolesResponse) HasApplicationIdentifier() bool {
	if o != nil && o.ApplicationIdentifier.IsSet() {
		return true
	}

	return false
}

// SetApplicationIdentifier gets a reference to the given NullableString and assigns it to the ApplicationIdentifier field.
func (o *GroupRolesResponse) SetApplicationIdentifier(v string) {
	o.ApplicationIdentifier.Set(&v)
}

// SetApplicationIdentifierNil sets the value for ApplicationIdentifier to be an explicit nil
func (o *GroupRolesResponse) SetApplicationIdentifierNil() {
	o.ApplicationIdentifier.Set(nil)
}

// UnsetApplicationIdentifier ensures that no value is present for ApplicationIdentifier, not even an explicit nil
func (o *GroupRolesResponse) UnsetApplicationIdentifier() {
	o.ApplicationIdentifier.Unset()
}

// GetRoles returns the Roles field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupRolesResponse) GetRoles() []Role {
	if o == nil {
		var ret []Role
		return ret
	}
	return o.Roles
}

// GetRolesOk returns a tuple with the Roles field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupRolesResponse) GetRolesOk() ([]Role, bool) {
	if o == nil || IsNil(o.Roles) {
		return nil, false
	}
	return o.Roles, true
}

// HasRoles returns a boolean if a field has been set.
func (o *GroupRolesResponse) HasRoles() bool {
	if o != nil && !IsNil(o.Roles) {
		return true
	}

	return false
}

// SetRoles gets a reference to the given []Role and assigns it to the Roles field.
func (o *GroupRolesResponse) SetRoles(v []Role) {
	o.Roles = v
}

func (o GroupRolesResponse) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GroupRolesResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.ApplicationId.IsSet() {
		toSerialize["applicationId"] = o.ApplicationId.Get()
	}
	if o.ApplicationIdentifier.IsSet() {
		toSerialize["applicationIdentifier"] = o.ApplicationIdentifier.Get()
	}
	if o.Roles != nil {
		toSerialize["roles"] = o.Roles
	}
	return toSerialize, nil
}

type NullableGroupRolesResponse struct {
	value *GroupRolesResponse
	isSet bool
}

func (v NullableGroupRolesResponse) Get() *GroupRolesResponse {
	return v.value
}

func (v *NullableGroupRolesResponse) Set(val *GroupRolesResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableGroupRolesResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableGroupRolesResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGroupRolesResponse(val *GroupRolesResponse) *NullableGroupRolesResponse {
	return &NullableGroupRolesResponse{value: val, isSet: true}
}

func (v NullableGroupRolesResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGroupRolesResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
